// JC Thu Apr  1 12:57:41 CEST 2004
// jednoduchy VAD ... 

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string>
#include <map>

#ifdef _WINDOWS
	#include "wfsource.h"
	#include "wspecgraf.h"
	#include <io.h>
#else
	#include <unistd.h>
	#include <sys/ioctl.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include "lwfsource.h"
	#include "specgraf.h"
#endif 

#include "config.h"
#include "dspc.h"
#include "lpc.h"
#include "filelen.h"


int main(int argc, char *argv[])
{
  // sem se budou ukladat LPC, LPCC nebo neco podobneho
  float fea_buffer[LEN_BUFFER][NO_FEATURES];
  // sem energie - podle te se bude strihat
  float ene; 
  float ene_buffer[LEN_BUFFER]; 
  // prah na energii - nutno rucne urcit !!!
  float ene_thr = ENE_THR;
  // vad buffer 
  int vad_buffer[LEN_BUFFER]; 
  // pocitani pro median 
  int kolik_1, kolik_0;
  // jake bylo posledni rozhodnuti 
  int last_vad=0; 
  // tvrde rozhodnuti 
  int vad; 
  // jmeno souboru pro vystup 
  char *outfilebase = "detected"; 
  // jmeno souboru pro vystup 
  int outfileno = 0; 
  // filehandle  souboru pro vystup 
  FILE *outfile = NULL; 
  // plne jmeno 
  char outfilename[256]; 


	try
	{
		// true - read from sound card, false - read from a file 
	  bool online = false;
	  //bool online = true;
		char *ifile = "test.l16";
		char *ofile = "out";

		// Input device, graph
		#ifdef _WINDOWS
			WFSource WFS;
			//WSpecGraf SG;
		#else
			LWFSource WFS;
			WFS.setDevice("/dev/dsp");
			//SpecGraf SG;
		#endif
		WFS.setFormat(8000, 1, 16);
		if(online)
		    WFS.open();

		// Features
		LPC Lpc;	
	
		// Output graph
		//     posY, posX, dx, dy, nbins, min_val, max_val
		// puvodne bylo SG.set(0, 0, -1, -1, BANKS, 0.0f, 50000.0f);
		//SG.set(0, 0, -1, -1, ENE_BUF_SIZE, 0.0f, 75000.0f);

		short *sgn;
		float *sgn_fl;
		float features[VECTOR_SIZE];
		FILE *fp_in, *fp_out;  
		
		// Input file and buffers
		if(online)
		{
		    sgn = new short[VECTOR_SIZE];
		    sgn_fl = new float[VECTOR_SIZE];
		}  
		else
		{
		    fp_in = fopen(ifile, "rb");
		    if(!fp_in)
		    {
			fprintf(stderr, "Can not open the file: %s\n", ifile);
			exit(1);
		    }
		    sgn = new short[filelen(fp_in)];
		    sgn_fl = new float[filelen(fp_in)];		    
		}
		
		// Output file
		fp_out = fopen(ofile, "wb");
		if(!fp_out)
		{
		    fprintf(stderr, "Can not create the file: %s\n", ofile);
		    exit(2);
		}


		int frame = 0;
		
		do
		{
			int i;

			if(online)
			{
			    WFS.read((char *)sgn, VECTOR_SIZE * sizeof(short));
			    
			    // shorts -> floats
	    		    for(i = 0; i < VECTOR_SIZE; i++)
				sgn_fl[i] = (float)sgn[i];
			    
			    Lpc.addWaveform(sgn_fl, VECTOR_SIZE);
			}
			else
			{
			    read(fileno(fp_in), (char *)sgn, filelen(fp_in));
			
			    // shorts -> floats
			    for(i = 0; i < filelen(fp_in) / 2; i++)
				sgn_fl[i] = (float)sgn[i];

			    Lpc.addWaveform(sgn_fl, filelen(fp_in) / 2);
			}
			    
			
			while(Lpc.getFeatures(features))
			{        
			  //printf("%d ", frame);
			  //frame++;
			    //int j;
			    //for(j = 10; j < 11; j++)
			    //printf(" %6.3f", features[j]);
			    //printf("\n");
			    //printf("%6.3f\n",features[10]);
			    
			    //fwrite(features, sizeof(float), 12, fp_out); 
			    

			    //*******************************************
			    // ted to bude docela humus, protoze nacpu vsechno do mainu ! hrozny !
			    // posunout buffery - velmi neprakticke !
			    int j;
			    for(i = 0; i < LEN_BUFFER-1; i++) {
			      ene_buffer[i] = ene_buffer[i+1]; 
			      vad_buffer[i] = vad_buffer[i+1]; 
			      for (j = 0; j < NO_FEATURES; j++)
				fea_buffer[i][j] = fea_buffer[i+1][j];
			    }
			    // naplnit nove hodnoty 
			    ene = features[10]; 
			    ene_buffer[LEN_BUFFER-1] = ene; 
			    for(j = 0; j < NO_FEATURES; j++)
			      fea_buffer[LEN_BUFFER-1][j] = features[j]; 
			    printf("%6.3f\n",ene_buffer[LEN_BUFFER-1]);

			    // detekujeme VAD - pokud energie pres prah
			    if (ene > ENE_THR)
			      vad_buffer[LEN_BUFFER-1] = 1;
			    else 
			      vad_buffer[LEN_BUFFER-1] = 0;

			    // vyhlazeni - median filtr, pak rozhodnuti
			    // zpetne pro prostredni vektor v bufferu. 
			    kolik_0 = kolik_1 = 0; 
			    for (i=0; i<LEN_BUFFER; i++)
			      if (vad_buffer[i] == 1) 
				kolik_1 ++;
			      else
				kolik_0 ++;
			    if (kolik_1 > kolik_0)
			      vad = 1;
			    else 
			      vad = 0; 
			    printf (" %d ",vad); 

			    // pokud nova detekce, otevreme novy soubor
			    // a stary zavreme (je-li jaky)
			    if (last_vad == 0 && vad == 1) {
			      if (outfile != NULL)
				fclose(outfile);
			      // udelat jmeno ... a otevrit. 
			      sprintf(outfilename,"%s%d",outfilebase,outfileno++);
			      printf("!!!!!!!!!!!!!!! %s\n",outfilename);
			      outfile = fopen(outfilename, "wb");
			      if(!outfile)
				{
				  fprintf(stderr, "Can not create the file: %s\n", outfilename);
				  exit(2);
				}
			    }
			    // pokud vad=1, neco tam napsat - Vy tam budete 
			    // psat sve features ! musi to ale jit ze stredu
			    // bufferu: 
			    if (vad ==1)
			      fwrite(&ene_buffer[LEN_BUFFER_STRED], sizeof(float), 1, outfile); 
			    // pro features to bude neco jako
			    //			    if (vad ==1)
			    //  fwrite(fea_buffer[LEN_BUFFER_STRED], sizeof(float), NO_FEATURES, outfile); 
	    
			    // hotovo, priradit minulemu 
			    last_vad = vad;
			    
			}
		} while(online);
		
		if(online)
		    WFS.close();
		else
		    fclose(fp_in);
		    
		//		fclose(fp_out);
		// zavrit vystupni file (byl-li otevren) ... 
		if (outfile != NULL)
		  fclose(outfile);

		
		delete [] sgn;
		delete [] sgn_fl;
	}
	catch(wf_error &er)
	{
		fprintf(stderr, "Sound recording error: %s\n", er.what());
		exit(1);
	}
	return 0;
}
