#include <stdio.h>
#include <stdlib.h>
#include "specgraf.h"

SpecGraf::SpecGraf()
{
	scr = initscr();
	clear();
}

SpecGraf::~SpecGraf()
{
	endwin();
}

void SpecGraf::set(int y, int x, int dy, int dx, int nbins, float min_val, float max_val)
{
	int max_x, max_y;
	getmaxyx(scr, max_y, max_x);
	if(dy == -1)
		dy = max_y + 1;
	if(dx == -1)
		dx = max_x + 1;
	
	this->x = x;
	this->y = y;
	this->dx = dx;
	this->dy = dy;
	this->max_val = max_val;
	this->min_val = min_val;
	this->nbins = nbins;
	
	stx = dx / nbins;
	if(stx < 1)
		stx = 1;
	
	sty = (max_val - min_val) / dy;
}

void SpecGraf::show(float *data)
{
	wclear(scr);
	int i, j, k, off_x = 0;
	for(i = 0; i < nbins; i++)
	{
		for(j = 0; j < stx; j++)
		{
			float v = (data[i] - min_val) / sty;
			int max = (int)(v + 0.5f);
			if(max < 0)
				max = 0;
			if(max > dy)
				max = dy;
			for(k = 0; k <= max; k++)
				mvwprintw(scr, dy - k + y - 2, off_x + x, "^");
			off_x++;
		}
	}
	refresh();
}

